'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var Yup = require('yup');
var formik = require('formik');
var React = _interopDefault(require('react'));
var ReactModal = _interopDefault(require('react-modal'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

var ButtonStyles = styled.css(["border:none;border-radius:0;background:none;position:relative;min-height:48px;cursor:", ";opacity:", ";", ";", ";", ";&:focus{outline:1px dashed ", ";}&:focus:not(.focus-visible){outline:none;}", ";"], function (props) {
  return props.disabled ? 'not-allowed' : 'pointer';
}, function (props) {
  return props.disabled ? '0.3' : '1';
}, function (props) {
  return props.primary ? "\n      background: ".concat(props.theme.buttonBackgroundColorPrimary, " ;\n      color: ").concat(props.theme.buttonColorPrimary, ";\n      font-size: ").concat(props.theme.fontSizeButtonPrimary, ";\n      padding: 0 1rem;\n    ") : '';
}, function (props) {
  return props.secondary ? "\n      background: ".concat(props.theme.buttonBackgroundColorSecondary, " ;\n      color: ").concat(props.theme.buttonColorSecondary, ";\n      font-size: ").concat(props.theme.fontSizeButtonSecondary, ";\n      padding: 0 1rem;\n    ") : '';
}, function (props) {
  return props.fullWidth ? "\n      width: 100% ;\n    " : '';
}, function (props) {
  return props.theme.colorOutline;
}, function (props) {
  return props.inheritedStyles ? props.inheritedStyles : '';
});

var Button = function Button(_ref) {
  var className = _ref.className,
      children = _ref.children,
      inheritedStyles = _ref.inheritedStyles,
      type = _ref.type,
      primary = _ref.primary,
      secondary = _ref.secondary,
      disabled = _ref.disabled,
      ariaLabel = _ref.ariaLabel,
      others = _objectWithoutProperties(_ref, ["className", "children", "inheritedStyles", "type", "primary", "secondary", "disabled", "ariaLabel"]);

  return React.createElement("button", _extends({
    "aria-label": ariaLabel || null,
    className: className,
    disabled: disabled,
    type: type
  }, others), children);
};

Button.defaultProps = {
  inheritedStyles: '',
  type: 'button',
  primary: false,
  secondary: false,
  disabled: false,
  ariaLabel: ''
};
var Button$1 = styled__default(Button).withConfig({
  displayName: "Button",
  componentId: "sc-1ccn477-0"
})(["", ";"], ButtonStyles);

var createUrlSearchParams = function createUrlSearchParams() {
  var query = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var queryParams = [];
  var keys = Object.keys(query);

  for (var i = 0, l = keys.length; i < l; i += 1) {
    queryParams.push("".concat(keys[i], "=").concat(query[keys[i]]));
  }

  return queryParams.join('&');
};
var buildUrl = function buildUrl(options) {
  if (_typeof(options) === 'object') {
    var pathname = options.pathname,
        query = options.query;
    var url = pathname;

    if (_typeof(query) === 'object') {
      url += "?".concat(createUrlSearchParams(query));
    }

    return url;
  }

  return options;
};

var styles = styled.css(["cursor:pointer;text-decoration:none;color:", ";&:focus{outline:1px dashed ", ";}", ";&:focus:not(.focus-visible){outline:none;}", ";"], function (props) {
  return props.theme.linkColorPrimary;
}, function (props) {
  return props.theme.colorOutline;
}, function (props) {
  return props.secondary ? "\n        font-weight: ".concat(props.theme.fontSemiBold, "\n        color: ").concat(props.theme.linkColorSecondary, "\n      ") : '';
}, function (props) {
  return props.inheritedStyles ? props.inheritedStyles : '';
});

var Anchor = function Anchor(_ref) {
  var children = _ref.children,
      to = _ref.to,
      as = _ref.as,
      className = _ref.className,
      inheritedStyles = _ref.inheritedStyles,
      handleLinkClick = _ref.handleLinkClick,
      shallow = _ref.shallow,
      scroll = _ref.scroll,
      forceClick = _ref.forceClick,
      others = _objectWithoutProperties(_ref, ["children", "to", "as", "className", "inheritedStyles", "handleLinkClick", "shallow", "scroll", "forceClick"]);

  return React.createElement("a", _extends({
    href: buildUrl(to),
    className: className,
    onClick: handleLinkClick
  }, others), children);
};

Anchor.defaultProps = {
  as: '',
  inheritedStyles: '',
  shallow: false,
  scroll: false,
  forceClick: false
};
var Anchor$1 = styled__default(Anchor).withConfig({
  displayName: "Anchor",
  componentId: "sc-1xnvnyd-0"
})(["", ";"], styles);

var styles$1 = styled.css(["letter-spacing:1px;font-weight:normal;font-family:", ";font-size:20px;", " ", " ", " ", " ", ""], function (props) {
  return props.theme.primaryFontFamily;
}, function (props) {
  return props.HeadingType === 'h2' ? 'font-size: 18px;' : '';
}, function (props) {
  return props.HeadingType === 'h3' ? 'font-size: 16px;' : '';
}, function (props) {
  return props.HeadingType === 'h4' ? 'font-size: 14px;' : '';
}, function (props) {
  return props.HeadingType === 'h5' ? 'font-size: 12px;' : '';
}, function (props) {
  return props.HeadingType === 'h6' ? 'font-size: 10px;' : '';
});

var Heading = function Heading(_ref) {
  var children = _ref.children,
      className = _ref.className,
      _ref$HeadingType = _ref.HeadingType,
      HeadingType = _ref$HeadingType === void 0 ? 'h1' : _ref$HeadingType,
      inheritedStyles = _ref.inheritedStyles,
      others = _objectWithoutProperties(_ref, ["children", "className", "HeadingType", "inheritedStyles"]);

  return React.createElement(HeadingType, _extends({
    className: className
  }, others), children);
};

Heading.defaultProps = {
  inheritedStyles: '',
  HeadingType: 'h1'
};
var Heading$1 = styled__default(Heading).withConfig({
  displayName: "Heading",
  componentId: "sc-1p0x9xg-0"
})(["", ";"], styles$1);

var styles$2 = styled.css(["letter-spacing:0px;font-weight:normal;font-family:", ";font-size:12px;"], function (props) {
  return props.theme.primaryFontFamily;
});

var Para = function Para(_ref) {
  var children = _ref.children,
      className = _ref.className,
      inheritedStyles = _ref.inheritedStyles,
      others = _objectWithoutProperties(_ref, ["children", "className", "inheritedStyles"]);

  return React.createElement("p", _extends({
    className: className
  }, others), children);
};

Para.defaultProps = {
  inheritedStyles: ''
};
var Para$1 = styled__default(Para).withConfig({
  displayName: "Para",
  componentId: "sc-1hv5xqb-0"
})(["", ";"], styles$2);

var styles$3 = styled.css(["font-family:", ";font-size:12px;text-align:left;color:", ";margin:0;", ";"], function (props) {
  return props.theme.fontFamilySecondary;
}, function (props) {
  return props.theme.textColorError;
}, function (props) {
  return props.inheritedStyles ? props.inheritedStyles : '';
});

var FieldError = function FieldError(_ref) {
  var className = _ref.className,
      children = _ref.children,
      dataSlnmId = _ref.dataSlnmId,
      inheritedStyles = _ref.inheritedStyles,
      others = _objectWithoutProperties(_ref, ["className", "children", "dataSlnmId", "inheritedStyles"]);

  return React.createElement(Para$1, _extends({
    className: className,
    "aria-live": "assertive",
    role: "alert",
    "data-slnm-id": dataSlnmId ? "".concat(dataSlnmId, "-error") : ''
  }, others), children);
};

FieldError.defaultProps = {
  dataSlnmId: '',
  inheritedStyles: '',
  className: ''
};
var FieldError$1 = styled__default(FieldError).withConfig({
  displayName: "FieldError",
  componentId: "sc-1b3h259-0"
})(["", ";"], styles$3);

var imageStyles = styled.css(["max-width:100%;height:auto;"]);

var Image = function Image(_ref) {
  var className = _ref.className,
      src = _ref.src,
      srcset = _ref.srcset,
      sizes = _ref.sizes,
      placeholderSrc = _ref.placeholderSrc,
      alt = _ref.alt,
      inheritedStyles = _ref.inheritedStyles,
      ref = _ref.ref,
      other = _objectWithoutProperties(_ref, ["className", "src", "srcset", "sizes", "placeholderSrc", "alt", "inheritedStyles", "ref"]);

  return React.createElement("img", _extends({
    className: className,
    src: src,
    srcSet: srcset || null,
    sizes: sizes || null,
    alt: alt,
    ref: ref
  }, other, {
    onError: placeholderSrc ? function (event) {
      // eslint-disable-next-line no-param-reassign
      event.target.src = placeholderSrc;
    } : null
  }));
};

Image.defaultProps = {
  srcset: '',
  sizes: '',
  placeholderSrc: '',
  inheritedStyles: ''
};
var Image$1 = styled__default(Image).withConfig({
  displayName: "Image",
  componentId: "sc-1m0q2wx-0"
})(["", ";"], imageStyles);

var styles$4 = styled.css(["margin:0;outline:0;line-height:1.2rem;padding:0.6rem 1rem;font-size:1rem;border-radius:0.2rem;background-color:", ";border:1px solid ", ";color:", ";", ";", ";"], function (props) {
  return props.theme.fieldBackgroundColor;
}, function (props) {
  return props.theme.fieldBorderColor;
}, function (props) {
  return props.theme.fieldTextColor;
}, function (props) {
  return props.disabled ? "\n      background-color: ".concat(props.theme.fieldBackgroundDisabledColor, ";\n      border-color: ").concat(props.theme.fieldBorderDisabledColor, ";\n    ") : '';
}, function (props) {
  return props.inheritedStyles ? props.inheritedStyles : '';
});

var Input = function Input(_ref) {
  var id = _ref.id,
      className = _ref.className,
      type = _ref.type,
      title = _ref.title,
      name = _ref.name,
      value = _ref.value,
      label = _ref.label,
      placeholder = _ref.placeholder,
      ariaLabel = _ref.ariaLabel,
      others = _objectWithoutProperties(_ref, ["id", "className", "type", "title", "name", "value", "label", "placeholder", "ariaLabel"]);

  return React.createElement("input", _extends({
    id: id,
    "aria-label": ariaLabel,
    className: className,
    name: name,
    type: type,
    value: value,
    placeholder: placeholder
  }, others));
};

Input.defaultProps = {
  placeholder: '',
  ariaLabel: '',
  className: '',
  type: 'text',
  value: ''
};
var Input$1 = styled__default(Input).withConfig({
  displayName: "Input",
  componentId: "sc-133uxg0-0"
})(["", ";"], styles$4);

var styles$5 = styled.css(["height:auto;background:", ";border:1px solid ", ";border-radius:0.2rem;padding:0.6rem 1rem;color:", ";", ";", ";"], function (props) {
  return props.theme.fieldBackgroundColor;
}, function (props) {
  return props.theme.fieldBorderColor;
}, function (props) {
  return props.theme.fieldTextColor;
}, function (props) {
  return props.disabled ? "\n      background: ".concat(props.theme.fieldBackgroundDisabledColor, ";\n      border-color: ").concat(props.theme.fieldBorderDisabledColor, ";\n    ") : '';
}, function (props) {
  return props.inheritedStyles ? props.inheritedStyles : '';
});

var Select = function Select(_ref) {
  var id = _ref.id,
      className = _ref.className,
      disabled = _ref.disabled,
      placeholder = _ref.placeholder,
      options = _ref.options,
      selectedOption = _ref.selectedOption,
      name = _ref.name,
      others = _objectWithoutProperties(_ref, ["id", "className", "disabled", "placeholder", "options", "selectedOption", "name"]);

  return React.createElement("select", _extends({
    id: id,
    name: name,
    className: className,
    value: selectedOption,
    disabled: disabled
  }, others), placeholder && React.createElement("option", {
    value: ""
  }, placeholder), options.map(function (opt) {
    return React.createElement("option", {
      key: opt,
      value: opt
    }, opt);
  }));
};

Select.defaultProps = {
  disabled: false,
  selectedOption: '',
  placeholder: '',
  className: ''
};
var Select$1 = styled__default(Select).withConfig({
  displayName: "Select",
  componentId: "sc-1s3i6e0-0"
})(["", ";"], styles$5);

var Label = function Label(_ref) {
  var className = _ref.className,
      htmlFor = _ref.htmlFor,
      children = _ref.children,
      others = _objectWithoutProperties(_ref, ["className", "htmlFor", "children"]);

  return (
    /* eslint-disable jsx-a11y/label-has-for */
    // FIXME: Remove the eslint comment above
    React.createElement("label", _extends({
      className: className,
      htmlFor: htmlFor
    }, others), children)
  );
};

Label.defaultProps = {
  className: ''
};

var styles$6 = styled.css(["margin:0;outline:0;line-height:1.2rem;padding:0.6rem 1rem;font-size:1rem;border-radius:0.2rem;background-color:", ";border:1px solid ", ";color:", ";resize:", ";width:100%;height:100px;", ";", ";"], function (props) {
  return props.theme.fieldBackgroundColor;
}, function (props) {
  return props.theme.fieldBorderColor;
}, function (props) {
  return props.theme.fieldTextColor;
}, function (props) {
  return props.resize || 'none';
}, function (props) {
  return props.disabled ? "\n      background-color: ".concat(props.theme.fieldBackgroundDisabledColor, ";\n      border-color: ").concat(props.theme.fieldBorderDisabledColor, ";\n    ") : '';
}, function (props) {
  return props.inheritedStyles ? props.inheritedStyles : '';
});

var Textarea = function Textarea(_ref) {
  var id = _ref.id,
      className = _ref.className,
      title = _ref.title,
      name = _ref.name,
      placeholder = _ref.placeholder,
      value = _ref.value,
      resize = _ref.resize,
      others = _objectWithoutProperties(_ref, ["id", "className", "title", "name", "placeholder", "value", "resize"]);

  return React.createElement("textarea", _extends({
    id: id,
    className: className,
    name: name,
    title: title,
    placeholder: placeholder,
    defaultValue: value,
    resize: resize
  }, others));
};

Textarea.defaultProps = {
  className: '',
  title: '',
  placeholder: '',
  value: '',
  resize: 'none'
};
var Textarea$1 = styled__default(Textarea).withConfig({
  displayName: "Textarea",
  componentId: "g6e5bs-0"
})(["", ";"], styles$6);

var getFieldValidation = function getFieldValidation(_ref) {
  var _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'string' : _ref$type,
      args = _objectWithoutProperties(_ref, ["type"]);

  var config = Yup[type]();
  var validationList = Object.keys(args); // TODO: Optimise this function and support nested Yup configs

  validationList.forEach(function (operation) {
    var _config;

    var validatorArgs = typeof args[operation] === 'string' ? Array(args[operation]) : args[operation];
    config = (_config = config)[operation].apply(_config, _toConsumableArray(validatorArgs));
  });
  return config;
};
/**
 * The function builds the schema from a plain object to YUP based config.
 * Consider the mentioned example at the start.
 */


var buildSchema = function buildSchema(rawSchema) {
  var schema = {};

  try {
    // listOfFields will be assigned ['username', 'password']
    var listOfFields = Object.keys(rawSchema);
    listOfFields.forEach(function (fieldName) {
      var field = rawSchema[fieldName];
      schema[fieldName] = getFieldValidation(field);
    });
    return Yup.object().shape(schema);
  } catch (e) {
    return schema;
  }
};

var noop = function noop() {
  return function () {
    return null;
  };
};

var Debug = function Debug() {
  return React.createElement("div", {
    style: {
      margin: '3rem 0',
      borderRadius: 4,
      background: '#f6f8fa',
      boxShadow: '0 0 1px  #eee inset'
    }
  }, React.createElement("div", {
    style: {
      textTransform: 'uppercase',
      fontSize: 11,
      borderTopLeftRadius: 4,
      borderTopRightRadius: 4,
      fontWeight: 500,
      padding: '.5rem',
      background: '#555',
      color: '#fff',
      letterSpacing: '1px'
    }
  }, "Debug Mode - Form State"), React.createElement(formik.FormikConsumer, null, function (_ref) {
    var validationSchema = _ref.validationSchema,
        validate = _ref.validate,
        onSubmit = _ref.onSubmit,
        rest = _objectWithoutProperties(_ref, ["validationSchema", "validate", "onSubmit"]);

    return React.createElement("pre", {
      style: {
        fontSize: 12,
        padding: '.25rem .5rem',
        overflowX: 'scroll'
      }
    }, JSON.stringify(rest, null, 2));
  }));
};

var styles$7 = styled.css(["margin-bottom:0.75rem;label{display:block;margin-bottom:0.25rem;}input{margin-bottom:0.25rem;}"]);

var FieldInput = function FieldInput(_ref) {
  var id = _ref.id,
      className = _ref.className,
      type = _ref.type,
      name = _ref.name,
      label = _ref.label,
      _onChange = _ref.onChange,
      _onBlur = _ref.onBlur,
      labelProps = _ref.labelProps,
      fieldProps = _ref.fieldProps,
      others = _objectWithoutProperties(_ref, ["id", "className", "type", "name", "label", "onChange", "onBlur", "labelProps", "fieldProps"]);

  return (// TODO: Add support for label position
    React.createElement("div", {
      className: className
    }, React.createElement(Label, _extends({
      htmlFor: id
    }, labelProps), label), React.createElement(formik.Field, _extends({
      id: id,
      name: name,
      type: type,
      render: function render(_ref2) {
        var field = _ref2.field,
            form = _ref2.form;
        var handleChange = form.handleChange,
            handleBlur = form.handleBlur;
        return React.createElement(Input$1, _extends({
          type: type
        }, others, field, {
          onChange: function onChange(e) {
            handleChange(e);
            if (typeof _onChange === 'function') _onChange(e, form);
          },
          onBlur: function onBlur(e) {
            handleBlur(e);
            if (typeof _onBlur === 'function') _onBlur(e, form);
          }
        }));
      }
    }, fieldProps)), React.createElement(formik.ErrorMessage, {
      name: name,
      component: FieldError$1
    }))
  );
};

FieldInput.defaultProps = {
  placeholder: '',
  className: '',
  type: 'text',
  labelProps: {},
  value: '',
  fieldProps: {},
  onChange: null,
  onBlur: null
};
var FieldInput$1 = styled__default(FieldInput).withConfig({
  displayName: "FieldInput",
  componentId: "sc-1gh57p3-0"
})(["", ";"], styles$7);

var styles$8 = styled.css(["margin-bottom:1rem;label{display:block;margin-bottom:0.25rem;}"]);

var FieldSelect = function FieldSelect(_ref) {
  var id = _ref.id,
      className = _ref.className,
      name = _ref.name,
      label = _ref.label,
      _onChange = _ref.onChange,
      labelProps = _ref.labelProps,
      fieldProps = _ref.fieldProps,
      others = _objectWithoutProperties(_ref, ["id", "className", "name", "label", "onChange", "labelProps", "fieldProps"]);

  return React.createElement("div", {
    className: className
  }, React.createElement(Label, _extends({
    htmlFor: id
  }, labelProps), label), React.createElement(formik.Field, _extends({
    name: name,
    component: "select",
    render: function render(_ref2) {
      var field = _ref2.field,
          form = _ref2.form;
      var handleChange = form.handleChange;
      return React.createElement(Select$1, _extends({}, others, field, {
        onChange: function onChange(e) {
          handleChange(e);
          if (typeof _onChange === 'function') _onChange(e, form);
        }
      }));
    }
  }, fieldProps)), React.createElement(formik.ErrorMessage, {
    name: name,
    component: FieldError$1
  }));
};

FieldSelect.defaultProps = {
  labelProps: {},
  fieldProps: {},
  onChange: null
};
var FieldSelect$1 = styled__default(FieldSelect).withConfig({
  displayName: "FieldSelect",
  componentId: "sc-1fkkiga-0"
})(["", ";"], styles$8);

var styles$9 = styled.css(["margin-bottom:1rem;label{display:block;margin-bottom:0.25rem;}"]);

var FieldTextarea = function FieldTextarea(_ref) {
  var id = _ref.id,
      className = _ref.className,
      type = _ref.type,
      name = _ref.name,
      _onChange = _ref.onChange,
      label = _ref.label,
      labelProps = _ref.labelProps,
      others = _objectWithoutProperties(_ref, ["id", "className", "type", "name", "onChange", "label", "labelProps"]);

  return React.createElement("div", {
    className: className
  }, React.createElement(Label, _extends({
    htmlFor: id
  }, labelProps), label), React.createElement(formik.Field, {
    id: id,
    name: name,
    render: function render(_ref2) {
      var field = _ref2.field,
          form = _ref2.form;
      var handleChange = form.handleChange;
      return React.createElement(Textarea$1, _extends({}, others, field, {
        onChange: function onChange(e) {
          handleChange(e);
          if (typeof _onChange === 'function') _onChange(e, form);
        }
      }));
    }
  }), React.createElement(formik.ErrorMessage, {
    name: name,
    component: FieldError$1
  }));
};

FieldTextarea.defaultProps = {
  className: '',
  labelProps: {},
  value: '',
  onChange: null
};
var FieldTextarea$1 = styled__default(FieldTextarea).withConfig({
  displayName: "FieldTextarea",
  componentId: "sc-9fr5lr-0"
})(["", ";"], styles$9);

var styles$a = styled.css(["cursor:", ";display:inline-flex;> input{display:none;}> span{border:2px solid ", ";width:20px;height:20px;position:relative;display:inline-block;vertical-align:middle;", " &::after{content:'';width:12px;height:12px;left:50%;top:50%;transform:translate(-50%,-50%) rotate(-45deg);position:absolute;", " ", ";}}& > input:checked + span{", " ", " &:after{", ";}}", ";"], function (props) {
  return props.disabled ? 'default' : 'pointer';
}, function (props) {
  return props.disabled ? props.theme.fieldBorderDisabledColor : props.theme.brandPrimaryColor;
}, function (props) {
  return props.type === 'radio' && "\n      border-radius: 50%;\n    ";
}, function (props) {
  return props.type === 'checkbox' && "\n        height: 6px;\n        border: 2px solid #fff;\n        border-width: 0 0 2px 2px;\n        top: calc(50% - 3px);\n      ";
}, function (props) {
  return props.type === 'radio' && "\n        border-radius: 50%;\n      ";
}, function (props) {
  return props.type === 'radio' ? "border-color: ".concat(props.disabled ? props.theme.fieldBorderDisabledColor : props.theme.brandPrimaryColor, ";") : '';
}, function (props) {
  return props.type === 'checkbox' && "\n      border-color: ".concat(props.disabled ? props.theme.fieldBorderDisabledColor : props.theme.brandPrimaryColor, ";\n      background-color: ").concat(props.disabled ? props.theme.fieldBorderDisabledColor : props.theme.brandPrimaryColor, ";\n      border-radius: 2px;\n    ");
}, function (props) {
  return props.type === 'radio' && "\n        background-color: ".concat(props.disabled ? props.theme.fieldBorderDisabledColor : props.theme.brandPrimaryColor, ";\n      ");
}, function (props) {
  return props.showLabelBeforeInput ? "\n    display: flex;\n    justify-content: space-between;\n    & > span {\n      order: 1;\n    }\n  " : "\n    & > span {\n      margin-right: 5px;\n    }\n  ";
});

var InputChoice = function InputChoice(_ref) {
  var id = _ref.id,
      name = _ref.name,
      type = _ref.type,
      checked = _ref.checked,
      disabled = _ref.disabled,
      className = _ref.className,
      label = _ref.label,
      children = _ref.children,
      showLabelBeforeInput = _ref.showLabelBeforeInput,
      labelProps = _ref.labelProps,
      otherProps = _objectWithoutProperties(_ref, ["id", "name", "type", "checked", "disabled", "className", "label", "children", "showLabelBeforeInput", "labelProps"]);

  return React.createElement(Label, _extends({
    className: className,
    htmlFor: id,
    showLabelBeforeInput: showLabelBeforeInput
  }, labelProps), React.createElement(Input, _extends({
    id: id,
    name: name,
    type: type,
    defaultChecked: checked,
    disabled: disabled
  }, otherProps)), React.createElement("span", {
    type: type
  }), React.createElement("div", null, children || label));
};

InputChoice.defaultProps = {
  checked: undefined,
  disabled: false,
  className: '',
  children: '',
  label: '',
  labelProps: {},
  showLabelBeforeInput: false
};
var InputChoice$1 = styled__default(InputChoice).withConfig({
  displayName: "InputChoice",
  componentId: "sc-1d450rw-0"
})(["", ";"], styles$a);

var styles$b = styled.css(["margin-bottom:1rem;"]);

var FieldRadioGroup = function FieldRadioGroup(_ref) {
  var id = _ref.id,
      className = _ref.className,
      name = _ref.name,
      radioGroupArray = _ref.radioGroupArray,
      others = _objectWithoutProperties(_ref, ["id", "className", "name", "radioGroupArray"]);

  return React.createElement(formik.FieldArray, {
    name: name,
    render: function render() {
      return React.createElement("div", _extends({
        className: className,
        id: id
      }, others), radioGroupArray.map(function (radioGroup, index) {
        return React.createElement(formik.Field, {
          key: radioGroup.id || "".concat(name, "_").concat(index),
          name: name,
          render: function render(_ref2) {
            var field = _ref2.field,
                form = _ref2.form;
            var handleChange = form.handleChange;
            var _onChange = radioGroup.onChange;
            return React.createElement(InputChoice$1, _extends({
              type: "radio",
              id: radioGroup.id || "".concat(name, "_").concat(index),
              onChange: function onChange(e) {
                handleChange(e);
                if (typeof _onChange === 'function') _onChange(e, form);
              }
            }, field, radioGroup));
          }
        });
      }), React.createElement(formik.ErrorMessage, {
        name: name,
        component: FieldError$1
      }));
    }
  });
};

FieldRadioGroup.defaultProps = {
  id: '',
  className: ''
};
var FieldRadioGroup$1 = styled__default(FieldRadioGroup).withConfig({
  displayName: "FieldRadioGroup",
  componentId: "sc-1xl52gz-0"
})(["", ";"], styles$b);

var styles$c = styled.css(["margin-bottom:1rem;"]);

var FieldCheckbox = function FieldCheckbox(_ref) {
  var id = _ref.id,
      className = _ref.className,
      name = _ref.name,
      _onChange = _ref.onChange,
      others = _objectWithoutProperties(_ref, ["id", "className", "name", "onChange"]);

  return React.createElement("div", {
    className: className
  }, React.createElement(formik.Field, {
    name: name,
    render: function render(_ref2) {
      var field = _ref2.field,
          form = _ref2.form;
      var handleChange = form.handleChange;
      return React.createElement(InputChoice$1, _extends({
        type: "checkbox",
        id: id || name
      }, field, others, {
        onChange: function onChange(e) {
          handleChange(e);
          if (typeof _onChange === 'function') _onChange(e, form);
        }
      }));
    }
  }), React.createElement(formik.ErrorMessage, {
    name: name,
    component: FieldError$1
  }));
};

FieldCheckbox.defaultProps = {
  id: '',
  className: '',
  onChange: null
};
var FieldCheckbox$1 = styled__default(FieldCheckbox).withConfig({
  displayName: "FieldCheckbox",
  componentId: "sc-1ia5ini-0"
})(["", ";"], styles$c);

var Form =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Form, _React$PureComponent);

  function Form() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Form);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Form)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.getSchema = function () {
      var yupValidationSchema = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var validationSchema = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      if (yupValidationSchema) return yupValidationSchema;
      return validationSchema ? buildSchema(validationSchema) : null;
    };

    return _this;
  }

  _createClass(Form, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          action = _this$props.action,
          className = _this$props.className,
          handleSubmit = _this$props.handleSubmit,
          initialValues = _this$props.initialValues,
          children = _this$props.children,
          debug = _this$props.debug,
          validationSchema = _this$props.validationSchema,
          validate = _this$props.validate,
          validateOnChange = _this$props.validateOnChange,
          validateOnBlur = _this$props.validateOnBlur,
          formWrapperProps = _this$props.formWrapperProps,
          yupValidationSchema = _this$props.yupValidationSchema,
          others = _objectWithoutProperties(_this$props, ["action", "className", "handleSubmit", "initialValues", "children", "debug", "validationSchema", "validate", "validateOnChange", "validateOnBlur", "formWrapperProps", "yupValidationSchema"]);

      return React.createElement(formik.Formik, _extends({
        initialValues: initialValues,
        validationSchema: this.getSchema(yupValidationSchema, validationSchema),
        validate: validate,
        onSubmit: handleSubmit,
        validateOnChange: validateOnChange,
        validateOnBlur: validateOnBlur,
        render: function render() {
          return React.createElement(formik.Form, _extends({
            noValidate: true
          }, others), children, debug && React.createElement(Debug, null));
        }
      }, formWrapperProps));
    }
  }]);

  return Form;
}(React.PureComponent);

Form.defaultProps = {
  debug: false,
  className: '',
  initialValues: null,
  validationSchema: null,
  validateOnChange: true,
  validateOnBlur: true,
  formWrapperProps: {},
  yupValidationSchema: null,
  validate: noop
};
Form.Input = FieldInput$1;
Form.Select = FieldSelect$1;
Form.Textarea = FieldTextarea$1;
Form.RadioGroup = FieldRadioGroup$1;
Form.Checkbox = FieldCheckbox$1;
Form.Field = formik.Field;

var styles$d = styled.css(["", ";"], function (props) {
  return props.inheritedStyles ? props.inheritedStyles : '';
});

var Modal = function Modal(_ref) {
  var isOpen = _ref.isOpen,
      onAfterOpen = _ref.onAfterOpen,
      onRequestClose = _ref.onRequestClose,
      closeTimeoutMS = _ref.closeTimeoutMS,
      style = _ref.style,
      contentLabel = _ref.contentLabel,
      portalClassName = _ref.portalClassName,
      overlayClassName = _ref.overlayClassName,
      className = _ref.className,
      bodyOpenClassName = _ref.bodyOpenClassName,
      htmlOpenClassName = _ref.htmlOpenClassName,
      ariaHideApp = _ref.ariaHideApp,
      shouldFocusAfterRender = _ref.shouldFocusAfterRender,
      shouldCloseOnOverlayClick = _ref.shouldCloseOnOverlayClick,
      shouldCloseOnEsc = _ref.shouldCloseOnEsc,
      shouldReturnFocusAfterClose = _ref.shouldReturnFocusAfterClose,
      role = _ref.role,
      parentSelector = _ref.parentSelector,
      aria = _ref.aria,
      overlayRef = _ref.overlayRef,
      contentRef = _ref.contentRef,
      others = _objectWithoutProperties(_ref, ["isOpen", "onAfterOpen", "onRequestClose", "closeTimeoutMS", "style", "contentLabel", "portalClassName", "overlayClassName", "className", "bodyOpenClassName", "htmlOpenClassName", "ariaHideApp", "shouldFocusAfterRender", "shouldCloseOnOverlayClick", "shouldCloseOnEsc", "shouldReturnFocusAfterClose", "role", "parentSelector", "aria", "overlayRef", "contentRef"]);

  return React.createElement(ReactModal, _extends({
    isOpen: isOpen,
    onAfterOpen: onAfterOpen,
    onRequestClose: onRequestClose,
    closeTimeoutMS: closeTimeoutMS,
    style: style,
    contentLabel: contentLabel,
    portalClassName: portalClassName,
    overlayClassName: overlayClassName,
    className: className,
    bodyOpenClassName: bodyOpenClassName,
    htmlOpenClassName: htmlOpenClassName,
    ariaHideApp: ariaHideApp,
    shouldFocusAfterRender: shouldFocusAfterRender,
    shouldCloseOnOverlayClick: shouldCloseOnOverlayClick,
    shouldCloseOnEsc: shouldCloseOnEsc,
    shouldReturnFocusAfterClose: shouldReturnFocusAfterClose,
    role: role,
    parentSelector: parentSelector,
    aria: aria,
    overlayRef: overlayRef,
    contentRef: contentRef
  }, others));
};

Modal.defaultProps = {
  onAfterOpen: noop,
  onRequestClose: noop,
  closeTimeoutMS: 0,
  style: {},
  contentLabel: '',
  portalClassName: '',
  overlayClassName: '',
  className: '',
  bodyOpenClassName: 'modalWrapper',
  htmlOpenClassName: '',
  ariaHideApp: false,
  shouldFocusAfterRender: true,
  shouldCloseOnOverlayClick: true,
  shouldCloseOnEsc: true,
  shouldReturnFocusAfterClose: true,
  role: 'dialog',
  parentSelector: function parentSelector() {
    return document && document.body;
  },
  aria: {},
  overlayRef: null,
  contentRef: null
};
var Modal$1 = styled__default(Modal).withConfig({
  displayName: "Modal",
  componentId: "ed59sz-0"
})(["", ";"], styles$d);

// Region Colors
var colors = {
  GREY: 'grey',
  RED: 'red',
  BLACK: '#000000',
  WHITE: '#ffffff',
  BRAND_PRIMARY: '#006193',
  BRAND_PRIMARY_SCALE_1: '#f3f3f3',
  BG_PRIMARY: '#fff',
  BG_SECONDARY: '#eaf2f6',
  OUTLINE: '#999',
  BG_PRIMARY_BUTTON: '#e57725',
  BG_SECONDARY_BUTTON: '#016fad',
  BORDER_SECONDARY: '#d9d9d9',
  BORDER_BLOCKS: '#b22029',
  LINK_PRIMARY: '#008CBA',
  TEXT_PRIMARY: '#222',
  TEXT_ALTERNATE: '#262626',
  TEXT_ALTERNATE_LIGHT: '#666',
  TEXT_LIGHT: '#dfdfdf',
  FIELD_BORDER: '#bfbfbf',
  FIELD_BORDER_LIGHT: '#bfdfdf',
  FIELD_BORDER_FOCUS: '#006193',
  ERROR: '#c00',
  SUCCESS: '#2e993a',
  CONTAINER_SHADOW_PRIMARY: 'rgba(0,0,0,.2)'
};

var FALLBACK_FONT = 'Arial, Helvetica, sans-serif';
var PRIMARY_FONT = "".concat(FALLBACK_FONT);
var SECONDARY_FONT = "".concat(FALLBACK_FONT);
var ICON_FONT = '';
var BASE_FONT_SIZE = '16px';
var DEFAULT_FONT_SIZE = '12px';
var HIGHLIGHT_FONT_SIZE = '18px';
var PRIMARY_FONT_SIZE_BUTTON = '24px';
var SECONDARY_FONT_SIZE_BUTTON = '16px';
var LETTER_SPACING = '0px';
var FONT_NORMAL = 'normal';
var FONT_BOOK = '400';
var FONT_MEDIUM = '500';
var FONT_SEMI_BOLD = '600';
var FONT_BOLD = '700';
var BASE_LINE_HEIGHT = '1.5'; // Typography

var fonts = {
  FALLBACK_FONT: FALLBACK_FONT,
  PRIMARY_FONT: PRIMARY_FONT,
  SECONDARY_FONT: SECONDARY_FONT,
  ICON_FONT: ICON_FONT,
  BASE_FONT_SIZE: BASE_FONT_SIZE,
  DEFAULT_FONT_SIZE: DEFAULT_FONT_SIZE,
  LETTER_SPACING: LETTER_SPACING,
  FONT_NORMAL: FONT_NORMAL,
  FONT_BOOK: FONT_BOOK,
  FONT_MEDIUM: FONT_MEDIUM,
  FONT_SEMI_BOLD: FONT_SEMI_BOLD,
  FONT_BOLD: FONT_BOLD,
  BASE_LINE_HEIGHT: BASE_LINE_HEIGHT,
  PRIMARY_FONT_SIZE_BUTTON: PRIMARY_FONT_SIZE_BUTTON,
  SECONDARY_FONT_SIZE_BUTTON: SECONDARY_FONT_SIZE_BUTTON,
  HIGHLIGHT_FONT_SIZE: HIGHLIGHT_FONT_SIZE
};

// z-index
var zIndex = {
  zLoader: 1000,
  zOverlay: 900,
  zSticky: 700,
  zNativeTickSelectIcon: 50
};

// Component dimension
var dimension = {
  PAGE_CONTENT_MAX_WIDTH: '80rem'
};

var theme = {
  fieldBorderColor: colors.FIELD_BORDER,
  fieldBorderDisabledColor: colors.FIELD_BORDER_LIGHT,
  fieldBorderFocusColor: colors.FIELD_BORDER_FOCUS,
  fieldBorderErrorColor: colors.ERROR,
  fieldBackgroundColor: colors.WHITE,
  fieldBackgroundDisabledColor: colors.BRAND_PRIMARY_SCALE_1,
  fieldTextColor: colors.TEXT_PRIMARY
};

var theme$1 = {
  linkColorPrimary: colors.LINK_PRIMARY,
  linkColorSecondary: colors.BG_SECONDARY_BUTTON,
  buttonBackgroundColorPrimary: colors.BG_PRIMARY_BUTTON,
  buttonBackgroundColorSecondary: colors.BG_SECONDARY_BUTTON,
  buttonColorPrimary: colors.WHITE,
  buttonColorSecondary: colors.WHITE
};

var theme$2 = {
  brandPrimaryColor: colors.BRAND_PRIMARY,
  textColorPrimary: colors.TEXT_PRIMARY,
  textColorSecondary: colors.TEXT_ALTERNATE,
  textColorSecondaryLight: colors.TEXT_ALTERNATE_LIGHT,
  textColorPlaceholder: colors.TEXT_LIGHT,
  textColorBrandPrimary: colors.BRAND_PRIMARY,
  textColorError: colors.ERROR,
  textColorSuccess: colors.SUCCESS,
  backgroundColorPrimary: colors.BG_PRIMARY,
  backgroundColorSecondary: colors.BG_SECONDARY,
  borderColorBoldest: colors.ERROR,
  borderColorSecondary: colors.BORDER_SECONDARY,
  colorOutline: colors.OUTLINE,
  backgroundColorSuccess: colors.SUCCESS,
  containerShadowPrimary: colors.CONTAINER_SHADOW_PRIMARY,
  fontFamilyDefault: fonts.FALLBACK_FONT,
  fontFamilyPrimary: fonts.PRIMARY_FONT,
  fontFamilySecondary: fonts.SECONDARY_FONT,
  fontFamilyIcon: fonts.ICON_FONT,
  fontSizeBase: fonts.BASE_FONT_SIZE,
  fontSizeDefault: fonts.DEFAULT_FONT_SIZE,
  fontSizeHighlight: fonts.HIGHLIGHT_FONT_SIZE,
  fontSizeButtonPrimary: fonts.PRIMARY_FONT_SIZE_BUTTON,
  fontSizeButtonSecondary: fonts.SECONDARY_FONT_SIZE_BUTTON,
  fontNormal: fonts.FONT_NORMAL,
  fontBook: fonts.FONT_BOOK,
  fontMedium: fonts.FONT_MEDIUM,
  fontSemiBold: fonts.FONT_SEMI_BOLD,
  fontBold: fonts.FONT_BOLD,
  letterSpacing: fonts.LETTER_SPACING,
  lineHeightBase: fonts.BASE_LINE_HEIGHT,
  maxWidthPageContent: dimension.PAGE_CONTENT_MAX_WIDTH
};

var themes = _objectSpread({
  zIndex: zIndex
}, theme, theme$1, theme$2);

/**
 * Atoms
 */

exports.Button = Button$1;
exports.ButtonVanilla = Button;
exports.Anchor = Anchor$1;
exports.AnchorVanilla = Anchor;
exports.Para = Para$1;
exports.ParaVanilla = Para;
exports.Heading = Heading$1;
exports.HeadingVanilla = Heading;
exports.FieldError = FieldError$1;
exports.FieldErrorVanilla = FieldError;
exports.Image = Image$1;
exports.ImageVanilla = Image;
exports.Input = Input$1;
exports.InputVanilla = Input;
exports.Select = Select$1;
exports.SelectVanilla = Select;
exports.Label = Label;
exports.Form = Form;
exports.Textarea = Textarea$1;
exports.TextareaVanilla = Textarea;
exports.InputChoice = InputChoice$1;
exports.InputChoiceVanilla = InputChoice;
exports.Modal = Modal$1;
exports.ModalVanilla = Modal;
exports.Theme = themes;
//# sourceMappingURL=bundle.cjs.js.map
